/* 

                          Firewall Builder

                 Copyright (C) 2002 NetCitadel, LLC

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: OSConfigurator.h 123 2008-07-05 17:38:52Z vadim $

  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __OSCONFIGURATOR_HH__
#define __OSCONFIGURATOR_HH__

#include "fwcompiler/Compiler.h"

#include "fwbuilder/FWException.h"
#include "fwbuilder/FWObjectDatabase.h"
#include "fwbuilder/FWOptions.h"
#include "fwbuilder/InetAddr.h"

#include <fstream>
#include <sstream>

namespace fwcompiler {

    class OSConfigurator : public Compiler {

        int num_virtual_addresses_for_nat;

public:

	virtual ~OSConfigurator();
	OSConfigurator(libfwbuilder::FWObjectDatabase *_db,
                       const std::string &fwname, bool ipv6_policy);

	virtual void processFirewallOptions() =0;
	virtual void addVirtualAddressForNAT(
            const libfwbuilder::Address   *addr) =0;
	virtual void addVirtualAddressForNAT(
            const libfwbuilder::Network   *nw)   =0;
        void registerVirtualAddressForNat() { num_virtual_addresses_for_nat++; }
        int getNumOfVirtualAddressesForNat() { return num_virtual_addresses_for_nat; }
    };
}

#endif
